/*
    This library function reads in additional strain and
    curvature data for the graphics program for beam elements.

		Updated 6/12/00

    SLFFEA source file
    Version:  1.1
    Copyright (C) 1999  San Le 

    The source code contained in this file is released under the
    terms of the GNU Library General Public License.
 
*/

#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include "../beam/bmconst.h"
#include "../beam/bmstruct.h"

extern int dof, nmat, numel, numnp;

int bmreader_gr( FILE *o1, MDIM *curve_node, SDIM *strain_node)
{
        int i,j,dum,dum2;
	char buf[ BUFSIZ ];
	char text;

        fgets( buf, BUFSIZ, o1 );
        fgets( buf, BUFSIZ, o1 );

        printf("strain for node: ");
        fscanf( o1,"%d",&dum);
        printf( "(%4d)",dum);
        while( dum > -1 )
        {
           fscanf( o1,"%lf ",&strain_node[dum].xx);
           fscanf( o1,"%lf ",&curve_node[dum].xx);
           fscanf( o1,"%lf ",&curve_node[dum].yy);
           fscanf( o1,"%lf ",&curve_node[dum].zz);
           printf(" %12.5e",strain_node[dum].xx);
           printf(" %12.5e",curve_node[dum].xx);
           printf(" %12.5e",curve_node[dum].yy);
           printf(" %12.5e",curve_node[dum].zz);
           fscanf( o1,"\n");
           printf( "\n");
           printf("strain for node: ");
           fscanf( o1,"%d",&dum);
           printf( "(%4d)",dum);
        }
        printf( "\n\n");

        return 1;
}

